#include <bits/stdc++.h>
#include <string>

using namespace std;

int main(int argc, char** argv) {
	
	
	long int q;
	long int n;
	cin >> n;
	long int c;
	cin >> c;
	cin >> q;
	string ulaz;
	cin >> ulaz;
	char s[n];
	for(long int i = 0; i < n; i++)
	{
		s[i]=ulaz[i];
	}
	long int duzina=sizeof(s);
	
	char sp[sizeof(s)];
	for(long int i = 0; i < sizeof(s); i++)
	{
		sp[i]=s[i];
	}	
	
	
	long int promene[2*q];	
	for(long int i = 0; i<2*q; i++)
		{
			cin >> promene[i];
		}
		

		
	for(long int i=0; i<2*q; i+=2)
	{
		for(promene[i];promene[i]<=promene[i+1];promene[i]++)
		{
			if(sp[promene[i]-1]=='1')
				{
					sp[promene[i]-1]='0';
				}
					else sp[promene[i]-1]='1';
		}
		
			char z[sizeof(s)];
		for(long int i = 0; i < sizeof(s); i++)
		{
			z[i]=sp[i];
		}
	
	//cout << "\n POLAZNI STRING" << " " << z << "\n";
			
	long int il=0;
	long int skracenol = 0;
	long int skracenod = 0;
	
	for(long int i=0; i < duzina; i++)
		{			
			if(z[i]=='1')
				{
					il=i;
					break;
				}
			skracenol++;		
		}
		
	for(long int j=duzina; j>=0; j--)
		{			
			if(z[j]=='1')
				{
					break;				
				}
			skracenod++;
		}
		
	char novi[duzina-skracenod-skracenol+1];	
	for(long int i=0; i<duzina-skracenod-skracenol+1; i++, il++)
		{
			novi[i]=z[il];
		}

	//cout << "\n POLAZNI STRING" << " " << novi << "\n";


	long int cena=0;
	long int duzina1=sizeof(novi);
	for(long int dpodniza = duzina1; dpodniza > c; dpodniza--)
	{	
		long int br1m=0;
		for(long int ip=0;ip <= duzina1-dpodniza+1;ip++ )
		{	
			long int br1 =0;
			for(long int i = ip; i<dpodniza+ip;i++)
				{					
						if(novi[i]=='1')	
							{
								br1++;
							}						
				}
			if(br1 > br1m)
				{
					br1m=br1;
				}	
			
		}
		for(long int ip2=0;ip2 <= duzina1-dpodniza+1;ip2++ )
		{	
			long int br2 =0;
			for(long int i = ip2; i<dpodniza+ip2;i++)
				{	
						if(novi[i]=='1')
							br2++;			
				}
			
			if(br2==br1m && br1m>=dpodniza-c && br1m != c  && novi[ip2]=='1' && novi[dpodniza+ip2-1]=='1')
				{	//cout << "br1m" << " " << br1m  << "dpodniza" << dpodniza << " " << br2 << "\n";
					for(long int i = ip2; i<dpodniza+ip2;i++)
						{	
							if(novi[i]=='1')
							{//cout << "uso ovde" << "\n";
								novi[i]='0';
							}
								else novi[i]='1';
						}
					cena+=c;
				}
		}			
	}
	long int dodatni = 0;
	for(long int i=0; i < duzina1;i++)
		{
			if(novi[i]=='1')
			dodatni++;
		}
		cena+=dodatni;
	//cout << novi << "\n";
	cout << cena << "\n";
	}
	
		
	
		
	return 0;
}